package MicroLang;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author       Adrian Knoth
 * @version 1.0
 */

public class ForTy extends StatTy{

  IdTy Id;
  ExprTy Expr1;
  ExprTy Expr2;
  StatTy Body;

  public ForTy() {
  }

  public ForTy(MicroToken Id, ExprTy Expr1, ExprTy Expr2,
               StatTy Body, StatTy NextStat) {

    this.Id = new IdTy(Id);
    this.Expr1 = Expr1;
    this.Expr2 = Expr2;
    this.Body = Body;
    this.NextStat = NextStat;
  }

  public void identify(BlockTy SurrBlock) throws MicroSemanticError
  {
    if (Id!=null) Id.identify(SurrBlock);
    else throw new MicroSemanticError("No Identifier in For-Loop");

    if (Expr1!=null) Expr1.identify(SurrBlock);
    else throw new MicroSemanticError("Lower Bound in For-Loop is missing");

    if (Expr2!=null) Expr2.identify(SurrBlock);
    else throw new MicroSemanticError("Upper Bound in For-Loop is missing");

    if (Body!=null) Body.identify(SurrBlock);
    else throw new MicroSemanticError("Statement body in For-Loop is missing");

    if (NextStat!=null) NextStat.identify(SurrBlock);

  }

  public String typCompat () throws MicroSemanticError {
  }
}
