package MicroLang;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author        Adrian Knoth
 * @version 1.0
 */

public class IdTy extends ExprTy {

  MicroToken Id;
  DefTy Definition;

  public IdTy() {
  }

  public IdTy(MicroToken Id) {
    this.Id = Id;
  }

  public void identify(BlockTy SurrBlock) throws MicroSemanticError
  {
    BlockTy CurrentBlock = SurrBlock;
    DefTy CurrentDef;

    while (CurrentBlock!=null) {
      CurrentDef=CurrentBlock.DefPart;

      while (CurrentDef!=null && CurrentDef.Valid) {
        if (this.Id.getTokenValue().equalsIgnoreCase(CurrentDef.Id.getTokenValue()))
        {
          this.Definition = CurrentDef;
          return;
        }
        else
          CurrentDef=CurrentDef.NextDef;
      }

      CurrentBlock = CurrentBlock.StaticPredecessor;
    }

    if ((!this.Id.getTokenValue().equalsIgnoreCase("false")) &&
        (!this.Id.getTokenValue().equalsIgnoreCase("true")) &&
        (!this.Id.getTokenValue().equalsIgnoreCase("Int32")) &&
        (!this.Id.getTokenValue().equalsIgnoreCase("Bool")))
      throw new MicroSemanticError("No Valid ID");

  }

  public String typCompat () throws MicroSemanticError {
  }
}